/**
 * Title:        Living Talks Web Conference Tool<p>
 * Description:  Tool using J2EE standards<p>
 * Copyright:    Copyright (c) Falk Langhammer<p>
 * Company:      Living Pages Research GmbH<p>
 * @author Falk Langhammer
 * @version 1.0
 */
package com.livis.livingtalks.client;

import com.livis.livingtalks.model.*;
import com.livis.livingtalks.ejb.*;
import java.util.*;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;

/*
 * ManageClient to test class ManageEJB
 */
public class TypeClient {

  public static void main (String [] args) {
    TypeModel t1 = new TypeModel (), t2 = new TypeModel (), t3 = new TypeModel ();
    t1.clear (); t1.setKey ("001"); t1.setDescription ("Desc 001");
    t2.clear (); t2.setKey ("002"); t1.setDescription ("Desc 002 (to be found)");
    t3.clear (); t3.setKey ("003"); t1.setDescription ("Desc 003");

    try {
 /***/ System.out.println (">>>connecting...");
       ManageHome home = LTUtils.getManageHome ();
 /***/ System.out.println (">>>creating session bean...");
       Manage mgr = home.create ();

 /***/ System.out.println (">>>create, update, find, and delete:");
       mgr.createType (t1);
 /***/ System.out.println (mgr.getTypeShortmodel ("001").getName () + ": " + mgr.getTypeModel ("001").getDescription());
       mgr.removeType ("001");

       mgr.createType (t3);  mgr.createType (t2);  mgr.createType (t1);

       TypeModel tt = mgr.getTypeModel ("002");
       tt.setDescription ("Modified Desc 002 (to be found)");
       mgr.setTypeModel (tt);
 /***/ System.out.println (mgr.getTypeShortmodel ("002").getName () + ": " + mgr.getTypeModel ("002").getDescription());

       Collection c = mgr.getTypeKeysAll ();
       Iterator   i = c.iterator ();
       while (i.hasNext ()) {
         String key = (String) i.next ();
         TypeModel model = mgr.getTypeModel (key);
 /***/   System.out.println (model.getName () + ": " + model.getDescription());
         mgr.removeType (key);
       }
 /***/ System.out.println (">>>all done.");
     }
     catch (Exception ex) {
       System.err.println (">>>Caught an exception<<<");
       ex.printStackTrace ();
     }
  }
}
