/**
 * Title:        Living Talks Web Conference Tool<p>
 * Description:  Living Talks Web Conference Tool using J2EE standards<p>
 *
 * <b>This file was automatically generated from a template!</b>
 *
 * Copyright:    Copyright (c) Oliver Imbusch<p>
 * Company:      Living Pages Research GmbH<p>
 * @author Oliver Imbusch
 * @version 1.0
 */
package com.livis.livingtalks.ejb;

import com.livis.flabes.util.*;
import com.livis.livingtalks.model.*;
import java.rmi.*;
import java.util.*;
import javax.ejb.*;

public class BlockEJB extends BlockModel implements EntityBean {

    public String ejbCreate (BlockModel model) throws CreateException {
	putModel (model);
	return null;
    }
    public void ejbPostCreate      (BlockModel model) throws CreateException { }
    public void ejbRemove          () throws RemoveException                 { }
    public void ejbActivate        ()                                        { restoreKeyFromContext (); }
    public void ejbPassivate       ()                                        { setKey (null); }
    public void ejbLoad            ()                                        { }
    public void ejbStore           ()                                        { }

    private EntityContext context;
    public void setEntityContext   (EntityContext context)                   { this.context = context; }
    public void unsetEntityContext ()                                        { setEntityContext (null); }

    //----------------------------------------------------------------------
    private void restoreKeyFromContext () { try { setKey ((String)context.getPrimaryKey ()); } catch (Exception ignore) { } }

    public BlockModel getModel () {
	BlockModel result    = super.getModel ();
	String     blockType = result.getBlockType ();
	if ("talk".equals (blockType)) {
	    // a block wrapper for a single talk: get data from
	    // enclosed talk
            if (mgr == null) mgr = LTUtils.createManage ();
	    try {
		// getTalkList()returns a single key iff there's only
		// one talk
		TalkModel talk = mgr.getTalkShortmodel (result.getTalkList ());
                if (talk != null) {
		    result.setTitle     (talk.getTitle ());
		    result.setTalkList  (talk.getKey ());
		    result.setAuthorKey (talk.getSpeaker ());
		    result.setDuration  (talk.getDuration ());
                }
	    } catch (RemoteException ignore) {
	    }
	} else if ("session".equals (blockType)) {
	    // a collection of talks: sum up durations
            if (mgr == null) mgr = LTUtils.createManage ();
	    try {
		int duration = 0;
		for (Iterator i = result.getTalks ().iterator (); i.hasNext (); ) {
		    TalkModel talk = mgr.getTalkShortmodel ((String) i.next ());
                    if (talk != null) duration += talk.getDuration ();
		}
		result.setDuration (duration);
	    } catch (RemoteException ignore) {
	    }
	}
	return result;
    }

    public void putModel (BlockModel model) throws CreateException {
        BlockModel copy = super.getModel ();
        try {
	    if (!("talk".equals (model.getBlockType ()) || "session".equals (model.getBlockType ()))) {
	        // neither a block wrapper for a talk nor a simple collection of talks, ie, a true block
	        if (1 == model.getTalks ().size ()) {
		    // fill in defaults from enclosed talk for unset fields
                    if (mgr == null) mgr = LTUtils.createManage ();
		    try {
		        // getTalkList() returns a single key iff there's only one talk
		        TalkModel talk = mgr.getTalkShortmodel (model.getTalkList ());
                        if (talk != null) {
		            if (StringUtils.isNullOrEmpty (model.getTitle ()))     model.setTitle     (talk.getTitle ());
		            if (StringUtils.isNullOrEmpty (model.getAuthorKey ())) model.setAuthorKey (talk.getSpeaker ());
		            if (0 == model.getDuration ())                         model.setDuration  (talk.getDuration ());
		        }
		    } catch (RemoteException ignore) {
		    }
	        }
            }
	    setModel (model);
	    if (shallCreateKey ()) {
	        checkForKeyCreation ();
                if (mgr == null) mgr = LTUtils.createManage ();
	        setKey (LTUtils.uniqueKey (mgr, "getBlockShortmodel", createKey ()));
	    }
	    setEditor (context.getCallerPrincipal ().getName ());
	    touch ();
	    check ();
        } catch (LivingTalksException le) { super.setModel (copy);      throw new LivingTalksCreateException (le);
        }
    }
    public void setEditor (String editor) { if (!context.isCallerInRole ("master")
                                            || getEditor () == null || getEditor ().equals ("")) super.setEditor (editor); }
    public void touch     ()              { if (!context.isCallerInRole ("master")
                                            || getTimestamp () == null || getTimestamp ().equals ("")) super.touch (); }
    private Manage mgr = null;
}
