/**
 * Title:        Living Talks Web Conference Tool<p>
 * Description:  Tool using J2EE standards<p>
 * Copyright:    Copyright (c) Dr. Falk Langhammer<p>
 * Company:      Living Pages Research GmbH<p>
 * @author Falk Langhammer
 * @version 1.0
 */
package com.livis.livingtalks.ejb;

import java.util.*;
import javax.ejb.CreateException;


public interface DataHandler {

  /** Write new data.
   *  @param data The data to be stored. data must not be <code>null</code>.
   *  @param key  The key under which the data should be stored. key may be <code>null</code>.
   *  @return the key under which the data finally got stored.
   *  @throws CreateException if key does already exist and no other key was used.
   */
  public String writeNew (String key, Object data) throws CreateException;

  /** Updates old data.
   *  @param data the data to be stored. A value of <code>null</code> will delete the data.
   *  @param key  The key under which to store the data. key must not be <code>null</code>.
   *  @throws CreateException if key does not exist
   */
  public void writeOld (String key, Object data) throws CreateException;

  /** Read data stored at key.
   *  @param key The key to retrieve the data for. A value of <code>null</code> will return null.
   *  @return The object previously stored, or <code>null</code> if no such data exists.
   *  @throws CreateException if key does not exist
   */
  public Object read (String key);
}