/**
 * Title:        Living Talks Web Conference Tool<p>
 * Description:  Tool using J2EE standards<p>
 * Copyright:    Copyright (c) Dr. Falk Langhammer<p>
 * Company:      Living Pages Research GmbH<p>
 * @author Falk Langhammer
 * @version 1.0
 */
package com.livis.livingtalks.ejb;

import com.livis.livingtalks.model.LivingTalksException;
import javax.ejb.CreateException;

public class LivingTalksCreateException extends CreateException {

  private Exception nested;

  public LivingTalksCreateException (LivingTalksException le) {
    super (le.getTitle () + "<br>\n" + le.getDetails ());
    this.nested = le;
  }

  public LivingTalksCreateException (Exception ex) {
    super (ex.getMessage ());
    this.nested = ex;
  }

  public LivingTalksCreateException (String message) {
    super (message);
    this.nested = null;
  }

  public LivingTalksCreateException () {
    this ("Error: The item could not be stored for no specified reason!");
  }

  public Exception getNested () {
    return nested;
  }
}