/**
 * Title:        Living Talks Web Conference Tool<p>
 * Description:  Tool using J2EE standards<p>
 * Copyright:    Copyright (c) Dr. Falk Langhammer<p>
 * Company:      Living Pages Research GmbH<p>
 * @author Falk Langhammer
 * @version 1.0
 */
package com.livis.livingtalks.ejb;

import com.livis.livingtalks.xml.ImportResult;
import java.rmi.*;
import javax.ejb.*;

public interface PublishIF {

    /** @param inSpec an absolute URL as a string */
    public ImportResult importXML        (String inSpec, String conference, int mode)             throws RemoteException;
    public ImportResult importXMLinOneTx (String inSpec, String conference, int mode)             throws RemoteException;
    public void         exportXML        (String outSpec)                                         throws RemoteException;
    public void         authors          (String outSpec, String fromSpec, String[] contextSpecs) throws RemoteException;
    public void         talks            (String outSpec, String fromSpec, String[] contextSpecs) throws RemoteException;
    public void         agenda           (String outSpec, boolean printAbstract,
                                                          String fromSpec, String[] contextSpecs) throws RemoteException;
    public void         overview         (String outSpec, String fromSpec, String[] contextSpecs) throws RemoteException;
}
