/**
 * Title:        Living Talks Web Conference Tool<p>
 * Description:  Living Talks Web Conference Tool using J2EE standards<p>
 *
 * <b>This file was automatically generated from a template!</b>
 *
 * Copyright:    Copyright (c) Oliver Imbusch<p>
 * Company:      Living Pages Research GmbH<p>
 * @author Oliver Imbusch
 * @version 1.0
 */
package com.livis.livingtalks.ejb;

import com.livis.livingtalks.model.*;
import java.rmi.*;
import java.util.*;
import javax.ejb.*;
import javax.naming.*;
import javax.rmi.*;

public class TalkEJB extends TalkModel implements EntityBean {

    public String ejbCreate (TalkModel model) throws CreateException {
	putModel (model);
	return null;
    }
    public void ejbPostCreate      (TalkModel model) throws CreateException { }
    public void ejbActivate        ()                                       { restoreKeyFromContext (); }
    public void ejbPassivate       ()                                       { setKey (null); }
    public void ejbLoad            ()                                       { }
    public void ejbStore           ()                                       { }

    private EntityContext context;
    public void setEntityContext   (EntityContext context)                  { this.context = context; }
    public void unsetEntityContext ()                                       { setEntityContext (null); }

    //----------------------------------------------------------------------
    private void restoreKeyFromContext () { try { setKey ((String)context.getPrimaryKey ()); } catch (Exception ignore) { } }

    // the following implement referrential integrity with Authorship and inherit from TalkModel methods
    public void ejbRemove () throws RemoveException {
        try {
            try {
                if (mgr == null) mgr = LTUtils.createManage ();
                for (Iterator i = mgr.getAuthorshipKeysByTalkKey (getKey ()).iterator (); i.hasNext (); )
                    mgr.removeAuthorship ((String) i.next ());
            } catch (Exception ex) {
                // Ok, coming here we will have broken referrential integrity. We must roll back the transaction!
                context.setRollbackOnly ();
                LTUtils.handleException (ex, this, null, "Authorship#Talk " + getKey ());
            }
        } catch (LivingTalksException le) { throw new RemoveException ("Remove of talk " + getKey () + " failed!<br>\n" + le.getTitle () + "<br>\n" + le.getDetails ());
        }
   }

    public TalkModel getModel () {
	try {
            if (mgr == null) mgr = LTUtils.createManage ();
	    Collection ckeys = mgr.getAuthorshipKeysByTalkKey (getKey ());
	    Collection al = new ArrayList (ckeys.size ());
	    for (Iterator i = ckeys.iterator (); i.hasNext (); )
		al.add (mgr.getAuthorshipShortmodel ((String) i.next ()).getAuthorKey ());
	    this.setAuthors (al);
	    return super.getModel ();
        } catch (RemoteException ex) { LTUtils.handleException (ex, this, null, getKey ()); return null;
	}
    }

    public void putModel (TalkModel model) throws CreateException {
        TalkModel copy = super.getModel ();
        try {
            setModel (model);
            if (shallCreateKey ()) {
                checkForKeyCreation ();
                if (mgr == null) mgr = LTUtils.createManage ();
	        setKey (LTUtils.uniqueKey (mgr, "getTalkShortmodel", createKey ()));
            }
            setEditor (context.getCallerPrincipal ().getName ());
            touch ();
            check ();
            try {
                if (mgr == null) mgr = LTUtils.createManage ();
                for (Iterator i = mgr.getAuthorshipKeysByTalkKey (getKey ()).iterator (); i.hasNext (); )
                    mgr.removeAuthorship ((String) i.next ());
        	for (Iterator i = getAuthors ().iterator (); i.hasNext (); )
         	    mgr.createAuthorship (new AuthorshipModel (getKey (), (String) i.next ()));
            } catch (Exception ex) {
                // Ok, coming here we will have broken referrential integrity. We must roll back the transaction!
                context.setRollbackOnly ();
                LTUtils.handleException (ex, this, null, "Authorship#Talk " + getKey ());
            }
        } catch (LivingTalksException le) { super.setModel (copy);      throw new LivingTalksCreateException (le);
        }
    }

    public void setEditor (String editor) { if (!context.isCallerInRole ("master")
                                            || getEditor () == null || getEditor ().equals ("")) super.setEditor (editor); }
    public void touch     ()              { if (!context.isCallerInRole ("master")
                                            || getTimestamp () == null || getTimestamp ().equals ("")) super.touch (); }
    public void check     ()              {
        super.check ();
        try {
            if (mgr == null) mgr = LTUtils.createManage ();
    	    TypeModel typeModel = mgr.getTypeShortmodel (getTypeKey ());
    	    if (!context.isCallerInRole ("master") && (typeModel == null ||
                !typeModel.isEditorInDuty (context.getCallerPrincipal ().getName ()))) {
    	        throw new LivingTalksException ("You have no write permission for category " + getTypeKey () + "!", this);
            }
        } catch (RemoteException re) { LTUtils.handleException (re, this, "Internal Error: Could not check permission!", getTypeKey ());
        }
    }
    private Manage mgr = null;
}
