/**
 * Title:        Living Talks Web Conference Tool<p>
 * Description:  Tool using J2EE standards<p>
 * Copyright:    Copyright (c) Dr. Falk Langhammer<p>
 * Company:      Living Pages Research GmbH<p>
 * @author Falk Langhammer
 * @version 1.0
 */
package com.livis.livingtalks.model;

public class LivingTalksException
    extends RuntimeException {

    public LivingTalksException (String title, Object thrower, Throwable nested) { this (title, thrower, nested, null); }

    public LivingTalksException (String title, Object thrower, Throwable nested, Throwable root) {
	super (title + ((null == nested) ? "" : "\nnested exception is:\n" + nested) + ((null == root) ? "" : "\nroot exception is:\n" + root));

	this.title   = title;
	this.root    = root;
	this.nested  = nested;
	this.details = "";
	if (root    != null) this.details += "The initial problem is:\n " + root;
	if (thrower != null) this.details += "\n\nThe problem occurred in class " + thrower.getClass ().getName ();
	if (nested  != null) this.details += "\n\nThe following exception was finally reported:\n" + nested;
    }

    public LivingTalksException (String title, Object thrower) { this (title, thrower, null); }

    private String title;
    public String getTitle () { return title; }

    private String details;
    public String getDetails () { return details; }

    private Throwable nested;
    public Throwable getNested () { return nested; }

    private Throwable root;
    public Throwable getRoot () { return root; }
}
