/**
 * Title:        Living Talks Web Conference Tool<p>
 * Description:  Living Talks Web Conference Tool
 * using J2EE standards<p>
 * Copyright:    Copyright (c) Oliver Imbusch<p>
 * Company:      Living Pages Research GmbH<p>
 * @author Oliver Imbusch
 * @version 1.0
 */
package com.livis.livingtalks.model;

import com.livis.flabes.util.*;
import java.util.*;

public class TypeModel
    extends AbstractModel {

    //----------------------------------------------------------------------
    // constructors/assignment
    //----------------------------------------------------------------------
    private TypeModel copy (TypeModel model) {
	return assignTypeModel (model.key, model.editor, model.timestamp,
				model.description, model.editorInDutyList, model.iconUrl, model.typePageUrl);
    }

    protected TypeModel assignTypeModel (String key, String editor, String timestamp,
					 String description, String editorInDutyList, String iconUrl, String typePageUrl) {

	super.assignAbstractModel (key, editor, timestamp);

	this.description      = description;
	this.editorInDutyList = editorInDutyList;
	this.iconUrl          = iconUrl;
	this.typePageUrl      = typePageUrl;

	return this;
    }

    public TypeModel getModel ()                { return (new TypeModel ()).copy (this); }
    public void      setModel (TypeModel model) { copy (model); }

    public void      init     ()                { assignTypeModel ("", "", "",
								   "", "", "", ""); }
    public void      clear    ()                { assignTypeModel ("", "", "",
								   "", "", "", ""); super.clear (); }
    //----------------------------------------------------------------------
    // CMP fields/properties
    //----------------------------------------------------------------------
    public String editorInDutyList = "";  // eg "user1|user2|user3"
    public String getEditorInDutyList ()                        { return editorInDutyList; }
    public void   setEditorInDutyList (String editorInDutyList) { setEditorsInDuty (Arrays.asList (StringUtils.split (editorInDutyList, '|'))); /* convert to TreeSet first to assure sorted uniqueness */ }
    public String description;
    public String getDescription      ()                    	{ return description; }
    public void   setDescription      (String description)  	{ this.description = description; }
    public String iconUrl;    	  
    public String getIconUrl          ()                    	{ return iconUrl; }
    public void   setIconUrl          (String iconUrl)      	{ this.iconUrl = iconUrl; }
    public String typePageUrl;	      
    public String getTypePageUrl      ()                    	{ return typePageUrl; }
    public void   setTypePageUrl      (String typePageUrl)  	{ this.typePageUrl = typePageUrl; }

    //----------------------------------------------------------------------
    // transient convenience wrappers/utilities
    //----------------------------------------------------------------------
    public Collection getEditorsInDuty ()                         { return Arrays.asList (StringUtils.split (getEditorInDutyList (), '|')); }
    public void       setEditorsInDuty (Collection editorsInDuty) { editorInDutyList = StringUtils.concat (new TreeSet (editorsInDuty), "|");  /* assure sorted uniqueness */ }
    public boolean    isEditorInDuty   (String     userName)      { return getEditorsInDuty ().contains (userName); }

    //----------------------------------------------------------------------
    // key wrapper
    //----------------------------------------------------------------------
    public String getName ()            { return getKey (); }
    public void   setName (String name) { setKey (name); }

    //----------------------------------------------------------------------
    // XML
    //----------------------------------------------------------------------
    private static List xmlTagProperties = new ArrayList ();
    protected List xmlTagPropertiesStore () { return xmlTagProperties; }
}
