/**
 * Title:        Living Talks Web Conference Tool<p>
 * Description:  Living Talks Web Conference Tool using J2EE standards<p>
 *
 * <b>This file was automatically generated from a template!</b>
 *
 * Copyright:    Copyright (c) Dr. Falk Langhammer<p>
 * Company:      Living Pages Research GmbH<p>
 * @author Falk Langhammer
 * @version 1.0
 */
package com.livis.livingtalks.web;

import com.livis.livingtalks.model.*;
import com.livis.livingtalks.ejb.*;
import com.livis.flabes.util.*;
import java.util.*;
import java.rmi.*;
import javax.ejb.*;


public class AuthorWebImpl extends AuthorModel {

    private Manage mgr = null;

    public AuthorWebImpl () {
        mgr = LTUtils.createManage (); // keep for session
    }

    public void processRequest (String request) {
	if (request == null) request = "";
	if (request.equals ("clear"))  { clear    (); }
	if (request.equals ("edit"))   { retrieve (); }
	if (request.equals ("view"))   { retrieve (); }
	if (request.equals ("copy"))   { retrieve (); setKey (getAutoKey ()); }
	if (request.equals ("add"))    { add      (); }
	if (request.equals ("add++"))  { add      (); clear (); }
	if (request.equals ("add+="))  { add      (); setKey (getAutoKey ()); }
	if (request.equals ("change")) { change   (); }
	if (request.equals ("delete")) { delete   (); }
    }

    public void retrieve () {
	try {
	    AuthorModel author = mgr.getAuthorModel (getKey ());
            if (author == null) throw new FinderException ("Item could not be found");
	    setModel (author);
	} catch (RemoteException re) { LTUtils.handleException (re, this, null, null);
	} catch (FinderException fe) { LTUtils.handleException (fe, this, null, getKey ());
	}
    }

    public void add () {
	try {
	    String key = mgr.createAuthor (getModel ());
	    AuthorModel author = mgr.getAuthorModel (key);
            if (author == null) throw new CreateException ("Created item disappeared");
	    setModel (author); // the key may have been generated
	} catch (RemoteException re) { LTUtils.handleException (re, this, null, null);
	} catch (CreateException ce) { LTUtils.handleException (ce, this, null, getKey ());
	}
    }

    public void change () {
	try {
	    mgr.setAuthorModel (getModel ());
	} catch (RemoteException re) { LTUtils.handleException (re, this, null, null);
	} catch (CreateException ce) { LTUtils.handleException (ce, this, null, getKey ());
	}
    }

    public void delete () {
	try {
	    mgr.removeAuthor (getKey ());
	} catch (RemoteException re) { LTUtils.handleException (re, this, null, null);
	} catch (RemoveException de) { LTUtils.handleException (de, this, null, getKey ());
	}
    }

    // @return a Collection of short AuthorModel(s)
    public Collection getModels () {
	try {
	    return mgr.getAuthorShortmodelsAll ();
	} catch (RemoteException re) { LTUtils.handleException (re, this, null, null); return null;
	}
    }

    // Convenience web menues stuff follows
    private String sepDisplay    = "----------------";
    public  String getSepDisplay ()                  { return sepDisplay; }
    public  void   setSepDisplay (String sepDisplay) { this.sepDisplay = sepDisplay; }

    private String selected      = "";
    public  String getSelected   ()                  { return selected.equals ("") ? null : selected; }
    public  void   setSelected   (String selected)   { this.selected = selected; }

    /** @return a menue listing all author keys, listing dangling authors (ie. in no talk) first */
    public WebMenu getAllAuthorsMenu () {
	try {
	    return new WebMenu ("", sepDisplay, mgr.getDanglingAuthorKeys (), mgr.getAuthorKeysAll (), getSelected ());
	} catch (RemoteException re) { LTUtils.handleException (re, this, null, null); return null;
	}
    }
}

