/**
 * Title:        Living Talks Web Conference Tool<p>
 * Description:  Living Talks Web Conference Tool using J2EE standards<p>
 *
 * <b>This file was automatically generated from a template!</b>
 *
 * Copyright:    Copyright (c) Dr. Falk Langhammer<p>
 * Company:      Living Pages Research GmbH<p>
 * @author Falk Langhammer
 * @version 1.0
 */
package com.livis.livingtalks.web;

import com.livis.livingtalks.model.*;
import com.livis.livingtalks.ejb.*;
import com.livis.flabes.util.*;
import java.util.*;
import java.rmi.*;
import javax.ejb.*;


public class BlockWebImpl extends BlockModel {

    private Manage mgr = null;

    public BlockWebImpl () {
        mgr = LTUtils.createManage (); // keep for session
    }

    public void processRequest (String request) {
	if (request == null) request = "";
	if (request.equals ("clear"))  { clear    (); }
	if (request.equals ("edit"))   { retrieve (); }
	if (request.equals ("view"))   { retrieve (); }
	if (request.equals ("copy"))   { retrieve (); setKey (getAutoKey ()); }
	if (request.equals ("add"))    { add      (); }
	if (request.equals ("add++"))  { add      (); clear (); }
	if (request.equals ("add+="))  { add      (); setKey (getAutoKey ()); }
	if (request.equals ("change")) { change   (); }
	if (request.equals ("delete")) { delete   (); }
    }

    public void retrieve () {
	try {
	    BlockModel block = mgr.getBlockModel (getKey ());
            if (block == null) throw new FinderException ("Item could not be found");
	    setModel (block);
	} catch (RemoteException re) { LTUtils.handleException (re, this, null, null);
	} catch (FinderException fe) { LTUtils.handleException (fe, this, null, getKey ());
	}
    }

    public void add () {
	try {
	    String key = mgr.createBlock (getModel ());
	    BlockModel block = mgr.getBlockModel (key);
            if (block == null) throw new CreateException ("Created item disappeared");
	    setModel (block); // the key may have been generated
	} catch (RemoteException re) { LTUtils.handleException (re, this, null, null);
	} catch (CreateException ce) { LTUtils.handleException (ce, this, null, getKey ());
	}
    }

    public void change () {
	try {
	    mgr.setBlockModel (getModel ());
	} catch (RemoteException re) { LTUtils.handleException (re, this, null, null);
	} catch (CreateException ce) { LTUtils.handleException (ce, this, null, getKey ());
	}
    }

    public void delete () {
	try {
	    mgr.removeBlock (getKey ());
	} catch (RemoteException re) { LTUtils.handleException (re, this, null, null);
	} catch (RemoveException de) { LTUtils.handleException (de, this, null, getKey ());
	}
    }

    /** @return a Collection of short BlockModel(s) */
    public Collection getModels () {
	try {
	    return mgr.getBlockShortmodelsAll ();
	} catch (RemoteException re) { LTUtils.handleException (re, this, null, null); return null;
	}
    }

    // Convenience web menues stuff follows
    private String sepDisplay    = "----------------";
    public  String getSepDisplay ()                  { return sepDisplay; }
    public  void   setSepDisplay (String sepDisplay) { this.sepDisplay = sepDisplay; }

    private String selected      = "";
    public  String getSelected   ()                  { return selected.equals ("") ? null : selected; }
    public  void   setSelected   (String selected)   { this.selected = selected; }

    /** @return a menue listing all block keys, listing dangling blocks (ie. in no pitem) first */
    public WebMenu getAllBlocksMenu () {
	try {
	    return new WebMenu ("", sepDisplay, mgr.getDanglingBlockKeys (), mgr.getBlockKeysAll (), getSelected ());
	} catch (RemoteException re) { LTUtils.handleException (re, this, null, null); return null;
	}
    }

    /** @return a menue listing all talks in this block */
    public WebMenu getTalksMenu () {
	return new WebMenu (getTalks ());
    }

    /** @return a menue listing of all blockTypes with block's type selected */
    public WebMenu getBlockTypeMenu () {
        WebMenu menue = new WebMenu ();
        menue.add ("talk");  menue.add ("session"); menue.add ("keynote");
        menue.add ("other"); menue.add ("break");   menue.add ("event");
        menue.selectFirst (getBlockType ());
	return menue;
    }
}
