/**
 * Title:        Living Talks Web Conference Tool<p>
 * Description:  Living Talks Web Conference Tool using J2EE standards<p>
 *
 * <b>This file was automatically generated from a template!</b>
 *
 * Copyright:    Copyright (c) Dr. Falk Langhammer<p>
 * Company:      Living Pages Research GmbH<p>
 * @author Falk Langhammer
 * @version 1.0
 */
package com.livis.livingtalks.web;

import com.livis.livingtalks.model.*;
import com.livis.livingtalks.ejb.*;
import com.livis.flabes.util.*;
import java.util.*;
import java.rmi.*;
import javax.ejb.*;


public class PitemWebImpl extends PitemModel {

    private Manage mgr = null;

    public PitemWebImpl () {
        mgr = LTUtils.createManage (); // keep for session
    }

    public void processRequest (String request) {
	if (request == null) request = "";
	if (request.equals ("clear"))  { clear    (); }
	if (request.equals ("edit"))   { retrieve (); }
	if (request.equals ("view"))   { retrieve (); }
	if (request.equals ("copy"))   { retrieve (); setKey (getAutoKey ()); }
	if (request.equals ("add"))    { add      (); }
	if (request.equals ("add++"))  { add      (); clear (); }
	if (request.equals ("add+="))  { add      (); setKey (getAutoKey ()); }
	if (request.equals ("change")) { change   (); }
	if (request.equals ("delete")) { delete   (); }
    }

    public void retrieve () {
	try {
	    PitemModel pitem = mgr.getPitemModel (getKey ());
            if (pitem == null) throw new FinderException ("Item could not be found");
	    setModel (pitem);
	} catch (RemoteException re) { LTUtils.handleException (re, this, null, null);
	} catch (FinderException fe) { LTUtils.handleException (fe, this, null, getKey ());
	}
    }

    public void add () {
	try {
	    String key = mgr.createPitem (getModel ());
	    PitemModel pitem = mgr.getPitemModel (key);
            if (pitem == null) throw new CreateException ("Created item disappeared");
	    setModel (pitem); // the key may have been generated
	} catch (RemoteException re) { LTUtils.handleException (re, this, null, null);
	} catch (CreateException ce) { LTUtils.handleException (ce, this, null, getKey ());
	}
    }

    public void change () {
	try {
	    mgr.setPitemModel (getModel ());
	} catch (RemoteException re) { LTUtils.handleException (re, this, null, null);
	} catch (CreateException ce) { LTUtils.handleException (ce, this, null, getKey ());
	}
    }

    public void delete () {
	try {
	    mgr.removePitem (getKey ());
	} catch (RemoteException re) { LTUtils.handleException (re, this, null, null);
	} catch (RemoveException de) { LTUtils.handleException (de, this, null, getKey ());
	}
    }

    /** @return a sorted Collection of short PitemModel(s) */
    public Collection getModels () {
	try {
	    SortedSet sortedPitemModels = new TreeSet (new
                Comparator () {
		    public int compare (Object lhsO, Object rhsO) {
		        PitemModel lhs = (PitemModel) lhsO;
			PitemModel rhs = (PitemModel) rhsO;
			int             order = lhs.getTrackKey ().compareTo (rhs.getTrackKey ());
			if (order == 0) order = lhs.getStart    ().compareTo (rhs.getStart    ());
                        if (order == 0) order = lhs.getKey      ().compareTo (rhs.getKey      ());
			return order;
		    }
	        }
            );
	    sortedPitemModels.addAll (mgr.getPitemShortmodelsAll ());
            return sortedPitemModels;
	} catch (RemoteException re) { LTUtils.handleException (re, this, null, null); return null;
	}
    }
}
