package com.livis.livingtalks.xml;

import com.livis.flabes.util.*;
import com.livis.livingtalks.ejb.*;
import com.livis.livingtalks.model.*;
import java.io.*;
import java.net.*;
import java.rmi.*;
import java.util.*;
import javax.ejb.*;

public class Agenda
    extends XMLOutput {

    //----------------------------------------------------------------------
    // constructors
    //----------------------------------------------------------------------
    public Agenda (boolean printTalkAbstract, String fromSpec, String[] contextSpecs) {
	super (fromSpec, contextSpecs);
	this.printTalkAbstract = printTalkAbstract;
    }
    public Agenda (                           String fromSpec, String[] contextSpecs) { this (false, fromSpec, contextSpecs); }

    //----------------------------------------------------------------------
    // class XMLExport
    //----------------------------------------------------------------------
    public void print (PrintWriter out, Indenter indenter) throws Exception {
	if (isPrintHeader ()) out.println ("<?xml version=\"1.0\" encoding=\"ISO-8859-1\" ?>");
	out.println (indenter + "<agenda>");

	printStartDates (out, indenter);

	out.println ("</agenda>");
    }

    //----------------------------------------------------------------------
    // utilities
    //----------------------------------------------------------------------
    private void printStartDates (PrintWriter out, Indenter indenter) throws FinderException, RemoteException, MalformedURLException {

        // As it turns out, dates compare such that embedded time is not always ignored...
 	SortedSet startDates = new TreeSet  (new
            Comparator () {
		public int compare (Object lhsO, Object rhsO) {
		    java.sql.Date lhs = (java.sql.Date) lhsO;
		    java.sql.Date rhs = (java.sql.Date) rhsO;
		    int             order = new Integer (lhs.getYear  ()).compareTo (new Integer (rhs.getYear  ()));
		    if (order == 0) order = new Integer (lhs.getMonth ()).compareTo (new Integer (rhs.getMonth ()));
		    if (order == 0) order = new Integer (lhs.getDate  ()).compareTo (new Integer (rhs.getDate  ()));
		    return order;
		}
	    }
        );
	Collection allTrackModels = mgr.getTrackShortmodelsAll ();
        for (Iterator i = allTrackModels.iterator (); i.hasNext (); ) startDates.add (((TrackModel) i.next ()).getDate ());

	if (!startDates.isEmpty ()) {
	    java.sql.Date firstDate = (java.sql.Date) startDates.iterator ().next ();
	    out.println (indenter.incLevel () + "<startDates>");
	    indenter.incLevel ();
	    for (Iterator s = startDates.iterator (); s.hasNext (); ) {
		out.println (indenter + "<startDate>");
		java.sql.Date date = (java.sql.Date)s.next ();
		out.println (indenter.incLevel () + "<day>" + (DateUtils.dayDifference (firstDate, date) + 1) + "</day>");

		SortedSet trackModels = new TreeSet (new
                    Comparator () {
			public int compare (Object lhsO, Object rhsO) {
			    TrackModel lhs = (TrackModel) lhsO;
			    TrackModel rhs = (TrackModel) rhsO;
			    int             order = new Integer (lhs.getPage     ()).compareTo (new Integer (rhs.getPage     ()));
                            if (order == 0) order = new Integer (lhs.getTrackCol ()).compareTo (new Integer (rhs.getTrackCol ()));
                            if (order == 0) order =              lhs.getKey      () .compareTo (             rhs.getKey      () );
			    return order;
			}
		    }
                );
                Collection dateTrackKeys = mgr.getTrackKeysByDate (date);
		for (Iterator i = dateTrackKeys.iterator (); i.hasNext (); )
                  trackModels.add (mgr.getTrackShortmodel ((String) i.next ()));
		printTracks (out, indenter, trackModels, null, null, null, null);

		out.println (indenter.decLevel () + "</startDate>");
	    }
	    out.println (indenter.decLevel () + "</startDates>");
	    indenter.decLevel ();
	}
    }
}
