package com.livis.livingtalks.xml;

import com.livis.flabes.util.*;
import com.livis.flabes.util.beans.*;
import com.livis.flabes.xml.*;
import com.livis.livingtalks.ejb.*;
import com.livis.livingtalks.model.*;
import java.io.*;
import java.rmi.*;
import java.util.*;
import javax.ejb.*;
import org.w3c.dom.*;

public class Authors
    extends XMLOutput {

    //----------------------------------------------------------------------
    // constructors
    //----------------------------------------------------------------------
    public Authors (String fromSpec, String[] contextSpecs) { super (fromSpec, contextSpecs); }

    //----------------------------------------------------------------------
    // class XMLExport
    //----------------------------------------------------------------------
    public void print (PrintWriter out, Indenter indenter) throws Exception {
	if (isPrintHeader ()) out.println ("<?xml version=\"1.0\" encoding=\"ISO-8859-1\" ?>");
	out.println (indenter + "<authors>");
	SortedSet authorModels = new TreeSet (new
            Comparator () {
		public int compare (Object lhsO, Object rhsO) {
		    return ((AuthorModel) lhsO).getKey ().compareTo (((AuthorModel) rhsO).getKey ());
		}
	    }
        );
        Collection authorKeys = mgr.getAuthorKeysAll ();
        for (Iterator i = authorKeys.iterator (); i.hasNext (); )
	  authorModels.add (mgr.getAuthorModel ((String) i.next ()));
	if (!authorModels.isEmpty ()) {
	    indenter.incLevel ();
	    for (Iterator am = authorModels.iterator (); am.hasNext (); ) {
		AuthorModel authorModel   = (AuthorModel) am.next ();
		authorModel.setCvHtml      (LTUtils.preformattedToHTML (authorModel.getCvHtml ()));
		// don't touch homePageUrl
		authorModel.setPhotoUrl    (relativeURLSpec (authorModel.getPhotoUrl ()));

		Document    doc           = DocumentFactory.createDocument ();
		Element     authorElement = new BeanToDOM (authorModel, doc, "author").toElement ();

                Collection authorshipKeys = mgr.getAuthorshipKeysByAuthorKey (authorModel.getKey ());
		SortedSet talkKeys = new TreeSet ();
                for (Iterator i = authorshipKeys.iterator (); i.hasNext (); )
                  talkKeys.add (mgr.getAuthorshipShortmodel ((String) i.next ()).getTalkKey ());

		if (!talkKeys.isEmpty ()) {
		    Element talksElement = doc.createElement ("talks");
		    authorElement.appendChild (talksElement);
		    for (Iterator t = talkKeys.iterator (); t.hasNext (); ) {
			String    talkKey   = (String) t.next ();
			TalkModel talkModel = mgr.getTalkShortmodel (talkKey);
			if (null != talkModel) {
			    Element talkElement = doc.createElement ("talk");
			    talksElement.appendChild (talkElement);
			    DOMUtils.append (talkElement, "key",   talkKey);
			    DOMUtils.append (talkElement, "title", talkModel.getTitle ());
			}
		    }
		}

		new DOMWriter (out, indenter).print (authorElement).println ();
	    }
	    indenter.decLevel ();
	}
	out.println (indenter + "</authors>");
    }
}
