/**
 * Title:        Living Talks Web Conference Tool<p>
 * Description:  Tool using J2EE standards<p>
 * Copyright:    Copyright (c) Dr. Falk Langhammer<p>
 * Company:      Living Pages Research GmbH<p>
 * @author Oliver Imbusch
 * @version 1.0
 */
package com.livis.livingtalks.xml;

import com.livis.flabes.util.*;
import com.livis.flabes.util.beans.*;
import com.livis.flabes.xml.*;
import com.livis.livingtalks.model.*;
import java.io.*;
import java.rmi.*;
import java.text.*;
import java.util.*;
import javax.ejb.*;
import org.w3c.dom.*;

public class Export extends XMLOutput {

    public static final String [] allContainerNames = new String [] {
	// CAUTION: don't change this workflow (ie, import) order!
	"author",
	"type",
	"talk",
	"authorship",
	"block",
	"track",
	"pitem",
    };

    //----------------------------------------------------------------------
    // constructors
    //----------------------------------------------------------------------
    public Export ()                                                { this ("Net.ObjectDays 2000"); }
    public Export (String conferenceName)                           { this (conferenceName, allContainerNames); }
    public Export (String conferenceName, String [] containerNames) {
	super ();
	this.conferenceName = conferenceName;
	this.containerNames = containerNames;
    }

    public void write (PrintStream out) { write (new OutputStreamWriter (out)); }

    //----------------------------------------------------------------------
    // class XMLOutput
    //----------------------------------------------------------------------
    public void print (PrintWriter out, Indenter indenter) throws IOException {
 	if (isPrintHeader ()) out.println ("<?xml version=\"1.0\" encoding=\"ISO-8859-1\" ?>");
	out.println ("<livingTalks-saveSet>");
	indenter.incLevel ();
	out.println (indenter + "<revision>" + DOMContainer.REVISION + "</revision>");

	String pattern = "dd.MM.yyyy HH:mm:ss";
	out.println (indenter + "<date format=\"" + pattern + "\"");
	out.println (indenter + " format-spec-url=\"http://java.sun.com/products/jdk/1.2/docs/api/java/text/SimpleDateFormat.html\"");
	out.println (indenter + " >" + new SimpleDateFormat (pattern).format (new Date ()) + "</date>");

	out.println (indenter + "<conferenceName>" + conferenceName + "</conferenceName>");
	out.println (indenter + "<entities>");
	indenter.incLevel ();
	for (int i = 0; i < containerNames.length; ++i) {
	    printContainer (out, indenter, containerNames [i]);
	}
	out.println (indenter.decLevel () + "</entities>");
	out.println (indenter.decLevel () + "</livingTalks-saveSet>");
    }

    //----------------------------------------------------------------------
    private String    conferenceName;
    private String [] containerNames;
}
