package com.livis.livingtalks.xml;

import com.livis.flabes.util.*;
import com.livis.flabes.util.beans.*;
import com.livis.flabes.xml.*;
import com.livis.livingtalks.ejb.*;
import com.livis.livingtalks.model.*;
import java.io.*;
import java.rmi.*;
import java.util.*;
import javax.ejb.*;
import org.w3c.dom.*;

public class Talks
    extends XMLOutput {

    //----------------------------------------------------------------------
    // constructors
    //----------------------------------------------------------------------
    public Talks (String fromSpec, String[] contextSpecs) {
	super (fromSpec, contextSpecs);
	printTalkAbstract = true;
	printTalkType     = false;
	printTalkPitem    = true;
    }

    //----------------------------------------------------------------------
    // class XMLExport
    //----------------------------------------------------------------------
    public void print (PrintWriter out, Indenter indenter) throws Exception {
	if (isPrintHeader ()) out.println ("<?xml version=\"1.0\" encoding=\"ISO-8859-1\" ?>");
	out.println (indenter + "<talks>");
	SortedSet typeModels = new TreeSet (new
            Comparator () {
		public int compare (Object lhsO, Object rhsO) {
		    return ((TypeModel) lhsO).getKey ().compareTo (((TypeModel) rhsO).getKey ());
		}
	    }
        );
	typeModels.addAll (mgr.getTypeShortmodelsAll ());
	if (!typeModels.isEmpty ()) {
	    out.println (indenter.incLevel () + "<types>");
	    indenter.incLevel ();
	    for (Iterator tm = typeModels.iterator (); tm.hasNext (); ) {
		TypeModel  typeModel   = (TypeModel)tm.next ();
		typeModel.setIconUrl     (relativeURLSpec (typeModel.getIconUrl ()));
		typeModel.setTypePageUrl (relativeURLSpec (typeModel.getTypePageUrl ()));

		Document   doc         = DocumentFactory.createDocument ();
		Element    typeElement = new BeanToDOM (typeModel, doc, "type").toElement ();
		DOMUtils.remove (typeElement, "editorInDutyList");

		Collection talkKeys = new TreeSet (mgr.getTalkKeysByTypeKey (typeModel.getKey ()));
		appendTalks (typeElement, talkKeys, new java.sql.Time (0), doc);

		new DOMWriter (out, indenter).print (typeElement).println ();
	    }
	    out.println (indenter.decLevel () + "</types>");
	    indenter.decLevel ();
	}
	out.println (indenter + "</talks>");
    }
}
