package com.livis.flabes.util;

import java.util.*;

public class DateUtils {

    private DateUtils () { }

    public static int getMinuteOfDay (Date date) { return (date.getHours () * minutesPerHour) + date.getMinutes (); }
    public static Date addMinutes (Date date, int minutes) { return new Date (date.getTime () + (minutes * millisecondsPerMinute)); }
    public static int dayDifference (Date d0, Date d1) { return (int)(Math.abs (d1.getTime () - d0.getTime ()) / millisecondsPerDay); }

    public static final int hoursPerDay      	  = 24;
    public static final int minutesPerHour   	  = 60;
    public static final int secondsPerMinute 	  = 60;
    public static final int millisecondsPerSecond = 1000;

    public static final int minutesPerDay         = hoursPerDay      * minutesPerHour;
    public static final int secondsPerDay         = minutesPerDay    * secondsPerMinute;
    public static final int millisecondsPerDay    = secondsPerDay    * millisecondsPerSecond;
  
    public static final int secondsPerHour        = minutesPerHour   * secondsPerMinute;
    public static final int millisecondsPerHour   = secondsPerHour   * millisecondsPerSecond;

    public static final int millisecondsPerMinute = secondsPerMinute * millisecondsPerSecond;
}
