package com.livis.flabes.util;

// have static noIndenter () which also prints no newLine, ie, is not
// equal to Indenter ("","") which does
public class Indenter {

    //----------------------------------------------------------------------
    // constructors
    //----------------------------------------------------------------------
    public Indenter (String prefix, String baseIndent, int level) { setPrefix (prefix); setBaseIndent (baseIndent); setLevel (level); }
    public Indenter (               String baseIndent, int level) { this ("", baseIndent, level); }
    public Indenter (String prefix, String baseIndent)            { this (prefix, baseIndent, 0); }
    // no           (       prefix,                        level) c'tor which conflicts with (baseIndent, level)
    public Indenter (               String baseIndent)            { this (baseIndent, 0); }
    // no           (       prefix                              ) c'tor which conflicts with (baseIndent)
    // no           (                                      level) c'tor which conflicts with (nBaseIndentChars)

    public Indenter (String prefix, int nBaseIndentChars, int level) { setPrefix (prefix); setBaseIndent (nBaseIndentChars); setLevel (level); }

    public Indenter (               int nBaseIndentChars, int level) { this ("", nBaseIndentChars, level); }
    // no           (       prefix,     nBaseIndentChars           ) c'tor which conflicts with (baseIndent, level)
    // no           (       prefix,                           level) c'tor which conflicts with (baseIndent, level)
    public Indenter (               int nBaseIndentChars)            { this (nBaseIndentChars, 0); }
    // no           (                                         level) which conflicts with (nBaseIndentChars)
    public Indenter ()                                               { this (0); }

    // fell free to add (nPrefixChars,..) permutations :-)

    //----------------------------------------------------------------------
    private String   prefix = "";
    public  String   getPrefix ()              { return prefix; }
    public  Indenter setPrefix (String prefix) { this.prefix = prefix; return setTotalIndent (); }

    //----------------------------------------------------------------------
    private String   baseIndent = "";
    public  String   getBaseIndent ()                        { return baseIndent; }
    public  Indenter setBaseIndent (String baseIndent)       { this.baseIndent = baseIndent; return setTotalIndent (); }
    public  Indenter setBaseIndent (int    nBaseIndentChars) { baseIndent = StringUtils.stringOf (" ", nBaseIndentChars); return setTotalIndent ();
    }

    //----------------------------------------------------------------------
    private int      level;
    public  int      getLevel ()           { return level; }
    public  Indenter setLevel (int level)  { this.level  = level; return setTotalIndent (); }
    public  Indenter incLevel (int amount) { return setLevel (getLevel () + amount); }
    public  Indenter incLevel ()           { return incLevel (1); }
    public  Indenter decLevel (int amount) { return setLevel (getLevel () - amount); }
    public  Indenter decLevel ()           { return decLevel (1); }

    //----------------------------------------------------------------------
    private String totalIndent;
    private Indenter setTotalIndent () {
	totalIndent = prefix + StringUtils.stringOf (baseIndent, level);
	return this;
    }

    //----------------------------------------------------------------------
    // I/O
    //----------------------------------------------------------------------
    public String toString () { return totalIndent; }
}
