package com.livis.flabes.xml;

import com.livis.flabes.util.*;

public class DOMParserFactory {

    private DOMParserFactory () { }

    private static String packageName = ClassUtils.packageName (DOMParserFactory.class.getName ());

    private static String defaultProvider;
    static {
 	try {
	    defaultProvider = System.getProperty (packageName + ".parser.provider");
 	} catch (Exception e) {
 	    // e.g. SecurityException in browser
 	}
	if (null == defaultProvider) {
	    defaultProvider = "Sun";
	}
    }

    public static String getDefaultProvider () { return defaultProvider; }
    public static void setDefaultProvider (String defaultProvider) { DOMParserFactory.defaultProvider = defaultProvider; }

    public static String getFullClassName (String provider) {
	return packageName + "." + provider + "DOMParser";
    }
    public static DOMParserInterface createDOMParser (String provider) {
	DOMParserInterface result = (DOMParserInterface)ClassUtils.newInstanceForNameCatching (getFullClassName (provider));
	if ((null == result) && (!defaultProvider.equals (provider))) {
	    result = (DOMParserInterface)ClassUtils.newInstanceForNameCatching (getFullClassName (defaultProvider));
	}
	return result;
    }
    public static DOMParserInterface createDOMParser () { return createDOMParser (defaultProvider); }
}
