// FIXME: remove DOMable interface?






package com.livis.flabes.xml;

import com.livis.flabes.util.*;
import com.livis.flabes.util.beans.*;
import java.beans.Introspector;
import java.io.*;
import java.lang.reflect.Method;
import org.w3c.dom.*;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

public class DOMUtils {

    private DOMUtils () { }
    
    //----------------------------------------------------------------------
    // DOM creation
    //----------------------------------------------------------------------
    public static void append (Element e, String tagName, String s) {
	Document doc = e.getOwnerDocument ();
	Element  tag = doc.createElement (tagName);
	tag.appendChild (doc.createTextNode (s));
	e.appendChild (tag);
    }

    public static void append (Element e, String tagName, boolean b) { append (e, tagName, "" + b); }
    public static void append (Element e, String tagName, int i)     { append (e, tagName, "" + i); }
    public static void append (Element e, String tagName, long l)    { append (e, tagName, "" + l); }
    // FIXME: handle null==o gracefully. Do we want
    // NullPointerException (ie, use toString())?
    public static void append (Element e, String tagName, Object o)  { append (e, tagName, "" + o); }

    //----------------------------------------------------------------------
    public static void remove (Element e, String tagName) {
	NodeList nodes  = e.getElementsByTagName (tagName);
	int      length = nodes.getLength ();
	for (int i = 0; i < length; ++i) {
	    e.removeChild (nodes.item (i));
	}
    }

    //----------------------------------------------------------------------
    public static String shortTagName (String className) {
	return ClassUtils.innerClassName (className);
    }
    // FIXME: other (ie, bean) package?
    // java.lang.StringBuffer -> stringBuffer
    public static String beanShortTagName (String className) {
	return Introspector.decapitalize (shortTagName (className));
    }

    //----------------------------------------------------------------------
    // DOM parsing
    //----------------------------------------------------------------------
    public static String getText (Element elem,
				  String  tagName) {
	return elem.getElementsByTagName (tagName).item (0).getFirstChild ().getNodeValue ();
    }

    //----------------------------------------------------------------------
    // XML file parsing
    //----------------------------------------------------------------------
//     public static void parseFile (String             fileName,
// 				  DOMParserInterface parser,
// 				  DOMable            result,
// 				  boolean            doValidate) {
// 	Document doc = null;
// 	try {
// 	    doc = parser.parse (new InputSource (new FileReader (fileName)), doValidate);
// 	} catch (Exception e) {
// 	    System.err.println ("error parsing file " + fileName);
// 	    e.printStackTrace ();
// 	}

// 	result.fromElement (doc.getDocumentElement ());
//     }

    //----------------------------------------------------------------------
    // XML file printing
    //
    // CAUTION: com.sun.xml.tree.XmlDocument's appendChild/write
    // methods cannot be used since the Nodes are checked whether they
    // have been created by the XmlDocument's factory 8(
    //
    // CAUTION: current implementation uses Apache-Xerces sample code
    // dom.DOMWriter, which prints to System.out *ONLY* and *DOES NOT*
    // accept doc types
    //
    // FIXME: replace by home-brewn implementation?
    //----------------------------------------------------------------------
//     private static XmlDocument toXmlDocument (String  docType,
// 					      Element root) {
// 	XmlDocument result = new XmlDocument ();
	
// 	// FIXME:
// 	result.setDoctype (null, docType, null);

// 	result.appendChild (root);
// 	return result;
//     }
//     public static void writeAsXML (String       docType,
// 				   Element      root,
// 				   OutputStream out) throws IOException {
// 	XmlDocument xmlDoc = toXmlDocument (docType, root);
// 	xmlDoc.write (out);
//     }
//     public static void writeAsXML (String  docType,
// 				   Element root,
// 				   Writer  out) throws IOException {
// 	XmlDocument xmlDoc = toXmlDocument (docType, root);
// 	xmlDoc.write (out);
//     }
//     public static void writeAsXML (String  docType,
// 				   Element root,
// 				   Writer  out,
// 				   String  encoding) throws IOException {
// 	XmlDocument xmlDoc = toXmlDocument (docType, root);
// 	xmlDoc.write (out, encoding);
//     }






//     public static void writeAsXML (// String      docType,
// 				   Element     root,
// // 				   PrintWriter out,
// 				   String      encoding) throws IOException {
// 	boolean       canonical = false;
// 	dom.DOMWriter writer    = new dom.DOMWriter (encoding, canonical);
// 	writer.print (root);
//     }
//     public static void writeAsXML (// String      docType,
// 				   Element     root
// // 				   PrintWriter out
// 				   ) throws IOException {
// 	boolean canonical = false;
// 	new dom.DOMWriter (canonical).print (root);
//     }




     public static void writeAsXML (// String      docType,
				    Element     root,
				    PrintWriter out,
				    String      encoding) throws IOException {
	 new DOMWriter (encoding, out).print (root);
     }
     public static void writeAsXML (// String      docType,
				    Element     root,
				    PrintWriter out) throws IOException {
	 new DOMWriter (out).print (root);
     }
     public static void writeAsXML (// String      docType,
				    Element  root,
				    Indenter indenter) throws IOException {
	 new DOMWriter (indenter).print (root).println ().flush ();
     }
     public static void writeAsXML (// String      docType,
				    Object      bean,
				    PrintWriter out) throws IOException {
	 new DOMWriter (out).print (new BeanToDOM (bean).toElement ()).println ().flush ();
     }
     public static void writeAsXML (// String      docType,
				    Object   bean,
				    Indenter indenter) throws IOException {
	 new DOMWriter (indenter).print (new BeanToDOM (bean).toElement ()).println ().flush ();
     }
     public static void writeAsXML (// String      docType,
				    Object bean) throws IOException {
	 new DOMWriter ()        .print (new BeanToDOM (bean).toElement ()).println ().flush ();
     }
}
