package com.livis.flabes.xml;

import com.livis.flabes.util.*;
import org.w3c.dom.Document;

public class DocumentFactory {

    private DocumentFactory () { }

    private static String packageName = ClassUtils.packageName (DocumentFactory.class.getName ());

    private static String defaultProvider;
    static {
 	try {
	    defaultProvider = System.getProperty (packageName + ".document.provider");
 	} catch (Exception e) {
 	    // e.g. SecurityException in browser
 	}
	if (null == defaultProvider) {
	    defaultProvider = "Sun";
	}
    }

    public static String getDefaultProvider () { return defaultProvider; }
    public static void setDefaultProvider (String defaultProvider) { DocumentFactory.defaultProvider = defaultProvider; }
    public static String getFullClassName (String provider) {
	return packageName + "." + provider + "Document";
    }
    public static Document createDocument (String provider) {

	Document result = (Document)ClassUtils.newInstanceForNameCatching (getFullClassName (provider));
	if ((null == result) && (!defaultProvider.equals (provider))) {
	    result = (Document)ClassUtils.newInstanceForNameCatching (getFullClassName (defaultProvider));
	}
	return result;
    }
    public static Document createDocument () { return createDocument (defaultProvider); }
}
