package com.livis.flabes.xml;

import org.xml.sax.ErrorHandler;
import org.xml.sax.SAXParseException;

class ErrorPrinter implements ErrorHandler {
    private void message (String level, SAXParseException e) {
	// FIXME: substring() to skip leading "file:", thus make it
	// parsable by XEmacs' makefile-mode
	System.out.println (e.getSystemId ().substring (5) + ":" + e.getLineNumber () + ": " + level + ": " + e.getMessage ());
	
	/*
	  if (e.getException () != null)
	  e.getException ().printStackTrace (System.out);
	  else
	  e.printStackTrace (System.out);
	*/
    }
    
    // normally a validity error
    public void error (SAXParseException e)      { message ("Error (recoverable)", e); }
    public void warning (SAXParseException e)    { message ("Warning", e); }
    public void fatalError (SAXParseException e) { message ("FATAL ERROR", e); }
}
