package com.livis.flabes.xml;

import java.util.*;
import org.w3c.dom.*;

public class NodeListIterator
    implements Iterator {

    //----------------------------------------------------------------------
    // constructors
    //----------------------------------------------------------------------
    public NodeListIterator (NodeList nodeList) {
	this.nodeList = nodeList;
	len           = nodeList.getLength ();
	i             = 0;
    }

    public NodeListIterator (Node node) { this (node.getChildNodes ()); }

    //----------------------------------------------------------------------
    // interface Iterator
    //----------------------------------------------------------------------
    public boolean hasNext () { return i < len; }
    public Object next () {
	if (!hasNext ()) {
	    throw new NoSuchElementException ("#" + i + "(last is " + (len - 1) + ")");
	}
	Object result = nodeList.item (i);
	++i;
	return result;
    }
    // optional, not supported
    public void remove () { throw new UnsupportedOperationException (getClass ().getName () + ".remove()"); }

    //----------------------------------------------------------------------
    private NodeList nodeList;
    private int      i;
    private int      len;
}

