package com.livis.flabes.xml;

import java.sql.*;

public class ResultSetToXML {

    //----------------------------------------------------------------------
    // constructors
    //----------------------------------------------------------------------
    private ResultSet resultSet;
    public ResultSetToXML (ResultSet resultSet) { this.resultSet = resultSet; }

    //----------------------------------------------------------------------
    // I/O
    //----------------------------------------------------------------------
    // cache conversion result
    private String xmlString;
    public String toString () {
	if (null == xmlString) {
	    try {
		ResultSetMetaData rsmd           = resultSet.getMetaData ();
		int               nColumns       = rsmd.getColumnCount ();
		// columns are indexed from 1..n, use array of length n+1
		// (and leave [0] unused) for fast indexing
		String[]          columnPrefixes = new String [nColumns + 1];
		StringBuffer      result         = new StringBuffer ("<result>\n");
		int               nRows          = 0;

		for (int i = 1; i <= nColumns; ++i) {
		    columnPrefixes [i] = "    <column name=\"" + rsmd.getColumnName (i) + "\">" ;
		}

		while (resultSet.next ()) {
		    ++nRows;
		    result.append ("  <row number=\"" + nRows + "\">\n");
		    for (int i = 1; i <= nColumns; ++i) {
			result.append (columnPrefixes [i]+ resultSet.getString (i) + "</column>\n");
		    }
		    result.append ("  </row>\n");
		}
		result.append ("</result>");
		xmlString = result.toString ();
	    } catch (Exception e) {
		xmlString = e.toString ();
	    }
	}
	return xmlString;
    }
}
